# ipfml.metrics

Functions which can be used to extract information from image

Functions

`get_LAB`(image) | Transforms RGB Image into Lab
`get_LAB_L`(image) | Transforms RGB Image into Lab and returns L
`get_LAB_a`(image) | Transforms RGB Image into LAB and returns a
`get_LAB_b`(image) | Transforms RGB Image into LAB and returns b
`get_SVD`(image) | Transforms Image using SVD compression
`get_SVD_U`(image) | Transforms Image into SVD and returns only ‘U’ part
`get_SVD_V`(image) | Transforms Image into SVD and returns only ‘V’ part
`get_SVD_s`(image) | Transforms Image into SVD and returns only ‘s’ part
`get_XYZ`(image) | Transforms RGB Image into XYZ
`get_XYZ_X`(image) | Transforms RGB Image into XYZ and returns X
`get_XYZ_Y`(image) | Transforms RGB Image into XYZ and returns Y
`get_XYZ_Z`(image) | Transforms RGB Image into XYZ and returns Z
`get_bits_img`(image, interval) | Returns only bits specified into the interval
`get_low_bits_img`(image[, nb_bits]) | Returns Image or Numpy array with data information reduced using only low bits
`gray_to_mscn`(image) | Convert Grayscale Image into Mean Subtracted Contrast Normalized (MSCN)

`ipfml.metrics.``get_LAB`(image)

  Transforms RGB Image into Lab

  Parameters: | image – image to convert
  Returns: | Lab information

  Usage:

      >>> from PIL import Image
      >>> from ipfml import metrics
      >>> img = Image.open('./images/test_img.png')
      >>> Lab = metrics.get_LAB(img)
      >>> Lab.shape
      (200, 200, 3)

`ipfml.metrics.``get_LAB_L`(image)

  Transforms RGB Image into Lab and returns L

  Parameters: | image – image to convert
  Returns: | The L chanel from Lab information

      >>> from PIL import Image
      >>> from ipfml import metrics
      >>> img = Image.open('./images/test_img.png')
      >>> L = metrics.get_LAB_L(img)
      >>> L.shape
      (200, 200)

`ipfml.metrics.``get_LAB_a`(image)

  Transforms RGB Image into LAB and returns a

  Parameters: | image – image to convert
  Returns: | The a chanel from Lab information

  Usage:

      >>> from PIL import Image
      >>> from ipfml import metrics
      >>> img = Image.open('./images/test_img.png')
      >>> a = metrics.get_LAB_a(img)
      >>> a.shape
      (200, 200)

`ipfml.metrics.``get_LAB_b`(image)

  Transforms RGB Image into LAB and returns b

  Parameters: | image – image to convert
  Returns: | The b chanel from Lab information

  Usage :

      >>> from PIL import Image
      >>> from ipfml import metrics
      >>> img = Image.open('./images/test_img.png')
      >>> b = metrics.get_LAB_b(img)
      >>> b.shape
      (200, 200)

`ipfml.metrics.``get_SVD`(image)

  Transforms Image using SVD compression

  Parameters: | image – image to convert into SVD compression
  Returns: | U, s, V obtained from SVD compression

  Usage:

      >>> from PIL import Image
      >>> from ipfml import metrics
      >>> img = Image.open('./images/test_img.png')
      >>> U, s, V = metrics.get_SVD(img)
      >>> U.shape
      (200, 200, 3)
      >>> len(s)
      200
      >>> V.shape
      (200, 3, 3)

`ipfml.metrics.``get_SVD_U`(image)

  Transforms Image into SVD and returns only ‘U’ part

  Parameters: | image – image to convert
  Returns: | U matrix from SVD compression

  Usage:

      >>> from PIL import Image
      >>> from ipfml import metrics
      >>> img = Image.open('./images/test_img.png')
      >>> U = metrics.get_SVD_U(img)
      >>> U.shape
      (200, 200, 3)

`ipfml.metrics.``get_SVD_V`(image)

  Transforms Image into SVD and returns only ‘V’ part

  Parameters: | image – image to convert
  Returns: | V matrix obtained from SVD compression

  Usage :

      >>> from PIL import Image
      >>> from ipfml import metrics
      >>> img = Image.open('./images/test_img.png')
      >>> V = metrics.get_SVD_V(img)
      >>> V.shape
      (200, 3, 3)

`ipfml.metrics.``get_SVD_s`(image)

  Transforms Image into SVD and returns only ‘s’ part

  Parameters: | image – image to convert
  Returns: | vector of singular values obtained from SVD compression

  Usage:

      >>> from PIL import Image
      >>> from ipfml import metrics
      >>> img = Image.open('./images/test_img.png')
      >>> s = metrics.get_SVD_s(img)
      >>> len(s)
      200

`ipfml.metrics.``get_XYZ`(image)

  Transforms RGB Image into XYZ

  Parameters: | image – image to convert
  Returns: | XYZ information obtained from transformation

  Usage:

      >>> from PIL import Image
      >>> from ipfml import metrics
      >>> img = Image.open('./images/test_img.png')
      >>> metrics.get_XYZ(img).shape
      (200, 200, 3)

`ipfml.metrics.``get_XYZ_X`(image)

  Transforms RGB Image into XYZ and returns X

  Parameters: | image – image to convert
  Returns: | The X chanel from XYZ information

  Usage:

      >>> from PIL import Image
      >>> from ipfml import metrics
      >>> img = Image.open('./images/test_img.png')
      >>> x = metrics.get_XYZ_X(img)
      >>> x.shape
      (200, 200)

`ipfml.metrics.``get_XYZ_Y`(image)

  Transforms RGB Image into XYZ and returns Y

  Parameters: | image – image to convert
  Returns: | The Y chanel from XYZ information

  Usage:

      >>> from PIL import Image
      >>> from ipfml import metrics
      >>> img = Image.open('./images/test_img.png')
      >>> y = metrics.get_XYZ_Y(img)
      >>> y.shape
      (200, 200)

`ipfml.metrics.``get_XYZ_Z`(image)

  Transforms RGB Image into XYZ and returns Z

  Parameters: | image – image to convert
  Returns: | The Z chanel from XYZ information
  Raises: | `ValueError` – If nb_bits has unexpected value. nb_bits needs to be in interval [1, 8].

  Usage:

      >>> from PIL import Image
      >>> from ipfml import metrics
      >>> img = Image.open('./images/test_img.png')
      >>> z = metrics.get_XYZ_Z(img)
      >>> z.shape
      (200, 200)

`ipfml.metrics.``get_bits_img`(image, interval)

  Returns only bits specified into the interval

  Parameters: | image – image to convert using this interval of bits value to keep interval – (begin, end) of bits values
  Returns: | Numpy array with reduced values
  Raises: | `ValueError` – If min value from interval is not >= 1. `ValueError` – If max value from interval is not <= 8. `ValueError` – If min value from interval >= max value.

  Usage:

      >>> from PIL import Image
      >>> from ipfml import metrics
      >>> img = Image.open('./images/test_img.png')
      >>> bits_img = metrics.get_bits_img(img, (2, 5))
      >>> bits_img.shape
      (200, 200, 3)

`ipfml.metrics.``get_low_bits_img`(image, nb_bits=4)

  Returns Image or Numpy array with data information reduced using only low bits

  Parameters: | image – image to convert nb_bits – optional parameter which indicates the number of bits to keep
  Returns: | Numpy array with reduced values

  Usage:

      >>> from PIL import Image
      >>> from ipfml import metrics
      >>> img = Image.open('./images/test_img.png')
      >>> low_bits_img = metrics.get_low_bits_img(img, 5)
      >>> low_bits_img.shape
      (200, 200, 3)

`ipfml.metrics.``gray_to_mscn`(image)

  Convert Grayscale Image into Mean Subtracted Contrast Normalized (MSCN)

  Parameters: | image – grayscale image
  Returns: | MSCN matrix obtained from transformation

  Usage:

      >>> from PIL import Image
      >>> from ipfml import metrics
      >>> img = Image.open('./images/test_img.png')
      >>> img = metrics.get_LAB_L(img)
      >>> img_mscn = metrics.gray_to_mscn(img)
      >>> img_mscn.shape
      (200, 200)